package biss.awt;

import java.awt.peer.ComponentPeer;

/**
 * interface used to asynchronously draw to panes (Lists etc.)
 * Very useful feature for accumulative painting (e.g. if some of
 * the draw operations are time consuming and should not slow down
 * the response-time of the system)
 * 
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author P.C.Mehlitz
 */
public interface DrawablePane
{
public void drawPane();

public ComponentPeer getPeer();

public boolean isShowing();

}
