import java.awt.*;

public class T1
  extends Frame
{
	static Font fnt = new Font( "Helvetica", Font.BOLD, 12);
	Font f1 = new Font( "Helvetica", Font.BOLD, 12);
	Font f2 = new Font( "Dialog", Font.PLAIN, 13);
	Font f3 = new Font( "TimesRoman", Font.ITALIC, 14);
	Font f4 = new Font( "Symbol", Font.BOLD, 12);
	Font f5 = new Font( "-b&h-lucidatypewriter-", Font.PLAIN, 13);
	FontMetrics fm1 = Toolkit.getDefaultToolkit().getFontMetrics( f1);
	FontMetrics fm2 = Toolkit.getDefaultToolkit().getFontMetrics( f2);
	FontMetrics fm3 = Toolkit.getDefaultToolkit().getFontMetrics( f3);
	FontMetrics fm4 = Toolkit.getDefaultToolkit().getFontMetrics( f4);
	Graphics gr;
	int x;
	int y;

public T1 ( String title ) {
	super( title);
}

String eventName ( int id ) {
	switch ( id ) {
	case Event.WINDOW_DESTROY:     return "WINDOW_DESTROY     ";
	case Event.WINDOW_EXPOSE:      return "WINDOW_EXPOSE      ";
	case Event.WINDOW_MOVED:       return "WINDOW_MOVED       ";
	case Event.KEY_PRESS:          return "KEY_PRESS          ";
	case Event.KEY_RELEASE:        return "KEY_RELEASE        ";
	case Event.KEY_ACTION:         return "KEY_ACTION         ";
	case Event.KEY_ACTION_RELEASE: return "KEY_ACTION_RELEASE ";
	case Event.MOUSE_DOWN:         return "MOUSE_DOWN         ";
	case Event.MOUSE_UP:           return "MOUSE_UP           ";
	case Event.MOUSE_ENTER:        return "MOSUE_ENTER        ";
	case Event.MOUSE_EXIT:         return "MOUSE_EXIT         ";
	case Event.MOUSE_MOVE:         return "MOUSE_MOVE         ";
	case Event.MOUSE_DRAG:         return "MOUSE_DRAG         ";
	case Event.GOT_FOCUS:          return "GOT_FOCUS          ";
	case Event.LOST_FOCUS:         return "LOST_FOCUS         ";
	}
	return "? " + id;
}

public boolean handleEvent ( Event e ) {

	/*
	  System.out.print( eventName(e.id));
	  // System.out.print( " when: " + e.when);
	  System.out.print( " x: " + e.x + " y: " + e.y);
	  System.out.print( " key: " + e.key + " mod: " + e.modifiers);
	  System.out.println( " click: " + e.clickCount);
	 */

	switch ( e.id ) {
	case Event.MOUSE_MOVE:
		if ( gr == null ) {
			gr = getGraphics();
			gr.setColor( Color.red);
			gr.setXORMode( getBackground());
		}
		else {
			gr.drawLine( 0, 0, x, y);
		}

		x = e.x;  y = e.y;
		gr.drawLine( 0, 0, x, y);
		break;
	case Event.WINDOW_DESTROY:
		dispose();
		System.exit(0);
		return true;
	}

	return false;
}

public static void main ( String[] args ) {
	T1 f = new T1( "T1");
	f.reshape( 100, 100, 200, 400);
	f.show();

	f.setCursor( Frame.CROSSHAIR_CURSOR);
}

public void paint ( Graphics g ) {
	Color[] clr = { Color.white, Color.lightGray, Color.gray, Color.darkGray,
		Color.black, Color.red, Color.pink, Color.orange,
		Color.yellow, Color.green, Color.magenta,
		Color.cyan, Color.blue };
	String[] cn = { "white", "lightGray", "gray", "darkGray",
		"black", "red", "pink", "orange", "yellow", "green",
		"magenta", "cyan", "blue" };

	int x = 10, x1 = 100;
	int y = 20;

	for ( int i=0; i < clr.length; i++ ) {
		g.setColor( Color.black);
		g.drawString( cn[i], x, y);
		g.setColor( clr[i]);
		g.fillRect( x1, y-10, 50, 12);
		g.setColor( Color.black);
		g.drawRect( x1, y-10, 50, 12);
		y += 20;
	}
}
}
